# coding=utf-8
# *** WARNING: this file was generated by the Pulumi SDK Generator. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._enums import *

__all__ = [
    'ChannelTag',
    'PlaybackKeyPairTag',
    'RecordingConfigurationDestinationConfiguration',
    'RecordingConfigurationRenditionConfiguration',
    'RecordingConfigurationS3DestinationConfiguration',
    'RecordingConfigurationTag',
    'RecordingConfigurationThumbnailConfiguration',
    'StreamKeyTag',
]

@pulumi.output_type
class ChannelTag(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        ChannelTag._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        return pulumi.get(self, "value")


@pulumi.output_type
class PlaybackKeyPairTag(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        PlaybackKeyPairTag._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        return pulumi.get(self, "value")


@pulumi.output_type
class RecordingConfigurationDestinationConfiguration(dict):
    """
    Recording Destination Configuration.
    """
    def __init__(__self__, *,
                 s3: Optional['outputs.RecordingConfigurationS3DestinationConfiguration'] = None):
        """
        Recording Destination Configuration.
        """
        RecordingConfigurationDestinationConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            s3=s3,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             s3: Optional['outputs.RecordingConfigurationS3DestinationConfiguration'] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if s3 is not None:
            _setter("s3", s3)

    @property
    @pulumi.getter
    def s3(self) -> Optional['outputs.RecordingConfigurationS3DestinationConfiguration']:
        return pulumi.get(self, "s3")


@pulumi.output_type
class RecordingConfigurationRenditionConfiguration(dict):
    """
    Rendition Configuration describes which renditions should be recorded for a stream.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "renditionSelection":
            suggest = "rendition_selection"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RecordingConfigurationRenditionConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RecordingConfigurationRenditionConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RecordingConfigurationRenditionConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 rendition_selection: Optional['RecordingConfigurationRenditionConfigurationRenditionSelection'] = None,
                 renditions: Optional[Sequence['RecordingConfigurationRenditionConfigurationRenditionsItem']] = None):
        """
        Rendition Configuration describes which renditions should be recorded for a stream.
        :param 'RecordingConfigurationRenditionConfigurationRenditionSelection' rendition_selection: Resolution Selection indicates which set of renditions are recorded for a stream.
        :param Sequence['RecordingConfigurationRenditionConfigurationRenditionsItem'] renditions: Renditions indicates which renditions are recorded for a stream.
        """
        RecordingConfigurationRenditionConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            rendition_selection=rendition_selection,
            renditions=renditions,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             rendition_selection: Optional['RecordingConfigurationRenditionConfigurationRenditionSelection'] = None,
             renditions: Optional[Sequence['RecordingConfigurationRenditionConfigurationRenditionsItem']] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if rendition_selection is not None:
            _setter("rendition_selection", rendition_selection)
        if renditions is not None:
            _setter("renditions", renditions)

    @property
    @pulumi.getter(name="renditionSelection")
    def rendition_selection(self) -> Optional['RecordingConfigurationRenditionConfigurationRenditionSelection']:
        """
        Resolution Selection indicates which set of renditions are recorded for a stream.
        """
        return pulumi.get(self, "rendition_selection")

    @property
    @pulumi.getter
    def renditions(self) -> Optional[Sequence['RecordingConfigurationRenditionConfigurationRenditionsItem']]:
        """
        Renditions indicates which renditions are recorded for a stream.
        """
        return pulumi.get(self, "renditions")


@pulumi.output_type
class RecordingConfigurationS3DestinationConfiguration(dict):
    """
    Recording S3 Destination Configuration.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "bucketName":
            suggest = "bucket_name"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RecordingConfigurationS3DestinationConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RecordingConfigurationS3DestinationConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RecordingConfigurationS3DestinationConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 bucket_name: str):
        """
        Recording S3 Destination Configuration.
        """
        RecordingConfigurationS3DestinationConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            bucket_name=bucket_name,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             bucket_name: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("bucket_name", bucket_name)

    @property
    @pulumi.getter(name="bucketName")
    def bucket_name(self) -> str:
        return pulumi.get(self, "bucket_name")


@pulumi.output_type
class RecordingConfigurationTag(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        RecordingConfigurationTag._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        return pulumi.get(self, "value")


@pulumi.output_type
class RecordingConfigurationThumbnailConfiguration(dict):
    """
    Recording Thumbnail Configuration.
    """
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "recordingMode":
            suggest = "recording_mode"
        elif key == "targetIntervalSeconds":
            suggest = "target_interval_seconds"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in RecordingConfigurationThumbnailConfiguration. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        RecordingConfigurationThumbnailConfiguration.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        RecordingConfigurationThumbnailConfiguration.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 recording_mode: Optional['RecordingConfigurationThumbnailConfigurationRecordingMode'] = None,
                 resolution: Optional['RecordingConfigurationThumbnailConfigurationResolution'] = None,
                 storage: Optional[Sequence['RecordingConfigurationThumbnailConfigurationStorageItem']] = None,
                 target_interval_seconds: Optional[int] = None):
        """
        Recording Thumbnail Configuration.
        :param 'RecordingConfigurationThumbnailConfigurationRecordingMode' recording_mode: Thumbnail Recording Mode, which determines whether thumbnails are recorded at an interval or are disabled.
        :param 'RecordingConfigurationThumbnailConfigurationResolution' resolution: Resolution indicates the desired resolution of recorded thumbnails.
        :param Sequence['RecordingConfigurationThumbnailConfigurationStorageItem'] storage: Storage indicates the format in which thumbnails are recorded.
        :param int target_interval_seconds: Target Interval Seconds defines the interval at which thumbnails are recorded. This field is required if RecordingMode is INTERVAL.
        """
        RecordingConfigurationThumbnailConfiguration._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            recording_mode=recording_mode,
            resolution=resolution,
            storage=storage,
            target_interval_seconds=target_interval_seconds,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             recording_mode: Optional['RecordingConfigurationThumbnailConfigurationRecordingMode'] = None,
             resolution: Optional['RecordingConfigurationThumbnailConfigurationResolution'] = None,
             storage: Optional[Sequence['RecordingConfigurationThumbnailConfigurationStorageItem']] = None,
             target_interval_seconds: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions]=None):
        if recording_mode is not None:
            _setter("recording_mode", recording_mode)
        if resolution is not None:
            _setter("resolution", resolution)
        if storage is not None:
            _setter("storage", storage)
        if target_interval_seconds is not None:
            _setter("target_interval_seconds", target_interval_seconds)

    @property
    @pulumi.getter(name="recordingMode")
    def recording_mode(self) -> Optional['RecordingConfigurationThumbnailConfigurationRecordingMode']:
        """
        Thumbnail Recording Mode, which determines whether thumbnails are recorded at an interval or are disabled.
        """
        return pulumi.get(self, "recording_mode")

    @property
    @pulumi.getter
    def resolution(self) -> Optional['RecordingConfigurationThumbnailConfigurationResolution']:
        """
        Resolution indicates the desired resolution of recorded thumbnails.
        """
        return pulumi.get(self, "resolution")

    @property
    @pulumi.getter
    def storage(self) -> Optional[Sequence['RecordingConfigurationThumbnailConfigurationStorageItem']]:
        """
        Storage indicates the format in which thumbnails are recorded.
        """
        return pulumi.get(self, "storage")

    @property
    @pulumi.getter(name="targetIntervalSeconds")
    def target_interval_seconds(self) -> Optional[int]:
        """
        Target Interval Seconds defines the interval at which thumbnails are recorded. This field is required if RecordingMode is INTERVAL.
        """
        return pulumi.get(self, "target_interval_seconds")


@pulumi.output_type
class StreamKeyTag(dict):
    def __init__(__self__, *,
                 key: str,
                 value: str):
        StreamKeyTag._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            key=key,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             key: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("key", key)
        _setter("value", value)

    @property
    @pulumi.getter
    def key(self) -> str:
        return pulumi.get(self, "key")

    @property
    @pulumi.getter
    def value(self) -> str:
        return pulumi.get(self, "value")


